From 6e282785a7b9fc3b635d4d3425e31dc66c7fca01 Mon Sep 17 00:00:00 2001
From: Walter Doekes <walter+github@wjd.nu>
Date: Sun, 20 Sep 2015 12:08:57 +0200
Subject: [PATCH 12/15] Fix channel unlock issue in Asterisk >= 12.

Thanks @bg111 for the review.
---
 at_response.c | 8 ++++----
 channel.c     | 7 +++++++
 2 files changed, 11 insertions(+), 4 deletions(-)

diff --git a/at_response.c b/at_response.c
index 3ac5411..c47d0ba 100644
--- a/at_response.c
+++ b/at_response.c
@@ -868,10 +868,10 @@ static int start_pbx(struct pvt* pvt, const char * number, int call_idx, call_st
 // FIXME: not execute if channel_new() failed
 	CPVT_SET_FLAGS(cpvt, CALL_FLAG_NEED_HANGUP);
 
-	// ast_pbx_start() usually failed if asterisk.conf minmemfree set too low, try drop buffer cache sync && echo 3 > /proc/sys/vm/drop_caches
-#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
-	ast_channel_unlock(channel);
-#endif /* ^13+ */
+	/* ast_pbx_start() usually failed if asterisk.conf minmemfree
+	 * set too low, try drop buffer cache
+	 * sync && echo 3 >/proc/sys/vm/drop_caches
+	 */
 	if (ast_pbx_start (channel))
 	{
 		ast_channel_tech_pvt_set(channel, NULL);
diff --git a/channel.c b/channel.c
index a14bcca..a4aaf92 100644
--- a/channel.c
+++ b/channel.c
@@ -1296,6 +1296,13 @@ EXPORT_DEF struct ast_channel* new_channel(
 
 			ast_module_ref (self_module());
 
+#if ASTERISK_VERSION_NUM >= 120000 /* 12+ */
+			/* commit e2630fcd516b8f794bf342d9fd267b0c905e79ce
+			 * Date:   Wed Dec 18 19:28:05 2013 +0000a
+			 * ast_channel_alloc() returns allocated channels locked. */
+			ast_channel_unlock(channel);
+#endif /* ^12+ */
+
 			return channel;
 		}
 		cpvt_free(cpvt);

